#NoEnv
SetBatchLines, -1
#SingleInstance, Force	




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; You select a file then
; It converts from "UTF-8 with BOM" to "UTF-8 without BOM" and vice versa
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; <<  Warining  >> 
; It does not make any BacukUps, it deals with the file you selected directly.
; You'd better keep original one safely.





SoundBeep, 2222, 44
SoundBeep, 2222, 44

FileSelectFile, fileNameExtension, 1, % A_WorkingDir "\select..." , select a File, You wanted ( *.*)
If ErrorLevel
	Goto, GuiEscape	
encodingCheckResult := Text_DetectEncoding( fileNameExtension)	

If(encodingCheckResult == "UTF-8 BOM")
{
	FileEncoding, UTF-8																			;	with	    BOM   
	FileRead, fileContent, % fileNameExtension	
	FileEncoding, UTF-8-RAW																	;	without BOM
	convertedMessage := "from`tUTF-8 BOM `n`nto`tUTF-8 no BOM"
}
Else If(encodingCheckResult == "UTF-8 w/o BOM")
{
	FileEncoding, UTF-8-RAW		
	FileRead, fileContent, % fileNameExtension	
	FileEncoding, UTF-8
	convertedMessage := "from`tUTF-8 no BOM `n`nto`tUTF-8 BOM"		
}
Else
{
	SoundBeep, 333, 555
	MsgBox, % "What the Hack is this ?" 
	ExitApp
}

FileDelete, % fileNameExtension	
FileAppend, % fileContent, % fileNameExtension																									
MsgBox, % convertedMessage

SoundBeep,   500, 50
SoundBeep,   500, 50
SoundBeep, 1500, 50
SoundBeep, 2500, 50
SoundBeep, 4500, 50
SoundBeep, 2500, 50
SoundBeep, 1500, 50
SoundBeep,   500, 50
ExitApp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GuiClose:
GuiEscape:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Soundbeep
Soundbeep
Exitapp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Text_DetectEncoding( txtFile) 														
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
{ 												
	hex := File_ReadAsHex( txtFile) 
	If ( ErrorLevel) 
		Return 
	If ( StrStartsWith( hex, "efbbbf")) 
		Return "UTF-8 BOM" 
	Else If ( StrStartsWith( hex, "feff")) 
		Return "UTF-16 Big Endian" 		
	Else If ( StrStartsWith( hex, "fffe")) 
		Return "UTF-16 Little Endian"
	Else If ( StrStartsWith( hex, "0000feff")) 
		Return "UTF-32 Big Endian"
	Else If ( StrStartsWith( hex, "fffe0000")) 
		Return "UTF-32 Little Endian"
	Else 
		{ 
			If ( __Text_CheckUtf8BytesWithHex( hex)) 
				Return "UTF-8 w/o BOM" 
			Return "What the Hack is this ?" 
		} 
} 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
__Text_CheckUtf8BytesWithHex( ByRef hex) 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
{ 
	idx := 1 
	len := StrLen( hex) // 2 
	isAllAsciiBytes := true 
	While ( idx <= len) 
	{ 
		firstByte := __Text_GetByteFromHex( hex, idx++) 
		If ( 0 <= firstByte && firstByte < 128) 
		{ 
			continue 
		} 
		Else If ( 192 <= firstByte && firstByte < 224) 
		{ 
			isAllAsciiBytes := false 
			If ( __Text_IsValidUtf8NonFirstByte( __Text_GetByteFromHex( hex, idx++))) 
				continue 
		} 
		Else If ( 224 <= firstByte && firstByte < 240) 
		{ 
			isAllAsciiBytes := false 
			If ( __Text_IsValidUtf8NonFirstByte( __Text_GetByteFromHex( hex, idx++)) 
				&& __Text_IsValidUtf8NonFirstByte( __Text_GetByteFromHex( hex, idx++))) 
				continue 
		} 
		Else If ( 240 <= firstByte && firstByte < 248) 
		{ 
			isAllAsciiBytes := false 
			If ( __Text_IsValidUtf8NonFirstByte( __Text_GetByteFromHex( hex, idx++)) 
				&& __Text_IsValidUtf8NonFirstByte( __Text_GetByteFromHex( hex, idx++)) 
				&& __Text_IsValidUtf8NonFirstByte( __Text_GetByteFromHex( hex, idx++))) 
				continue 
		} 
		Return false 
	} 
	Return !isAllAsciiBytes 
} 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
__Text_GetByteFromHex( ByRef hex, idx) 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
{ 
	tmp := ( "0x" . SubStr( hex, idx * 2 - 1, 2)), tmp += 0 
	Return tmp 
} 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
__Text_IsValidUtf8NonFirstByte( byte) 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
{ 
	Return 128 <= byte && byte < 192 
} 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
File_ReadAsHex( fileName, bytesToRead="-1") 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
{ 
	If ( ( hFile := DllCall( "CreateFile", "Str", fileName, "UInt", 0x80000000, "UInt", 0, "UInt", 0, "UInt", 3, "UInt", 0x00000080, "UInt", 0)) == -1) 
	{ 
		ErrorLevel := 1 
		Return 
	} 
	bufferSize := 256 
	VarSetCapacity( buffer, bufferSize, 0) 
	content := 
	totalBytesRead := 0 
	Loop 
	{ 
		If ( DllCall( "ReadFile", "UInt", hFile, "Str", buffer, "UInt", bufferSize, "UIntP", bytesActuallyRead, "UInt", 0) == 0) 
		{ 
			DllCall( "CloseHandle", "UInt", hFile) 
			buffer := 
			ErrorLevel := 1 
			Return 
		} 
		If ( bytesActuallyRead == 0) 				
			break 
		SetFormat, Integer, h 
		Loop, %bytesActuallyRead% 
		{ 
			hex := SubStr( NumGet( buffer, A_Index - 1, "UChar") + 0, 3) 		
			content .= ( StrLen( hex) == 1 ? "0" . hex : hex) 
			If ( bytesToRead != -1 && ++totalBytesRead == bytesToRead) 
			break 
		} 
		SetFormat, Integer, d 
		If ( bytesToRead != -1 && totalBytesRead == bytesToRead) 
			break 
	} 
	DllCall( "CloseHandle", "UInt", hFile) 
	buffer := 
	ErrorLevel := 0 
	Return content 
} 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
StrStartsWith( str, prefix) 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
{ 
	Return RegExMatch( str, "^" . prefix) 
}

